CREATE TABLE datasci.ads_industry_new_acc_retention_d (
    ds text NOT NULL,
    tag text NOT NULL,
    ret1_avg numeric(10,4),
    ret1_50 numeric(10,4),
    ret1_70 numeric(10,4),
    ret1_80 numeric(10,4),
    ret1_90 numeric(10,4),
    ret7_avg numeric(10,4),
    ret7_50 numeric(10,4),
    ret7_70 numeric(10,4),
    ret7_80 numeric(10,4),
    ret7_90 numeric(10,4),
    ret15_avg numeric(10,4),
    ret15_50 numeric(10,4),
    ret15_70 numeric(10,4),
    ret15_80 numeric(10,4),
    ret15_90 numeric(10,4),
    ret30_avg numeric(10,4),
    ret30_50 numeric(10,4),
    ret30_70 numeric(10,4),
    ret30_80 numeric(10,4),
    ret30_90 numeric(10,4),
    PRIMARY KEY (ds, tag)
)

CREATE TABLE datasci.ads_industry_role_ratio_d (
    ds text NOT NULL,
    tag text NOT NULL,
    proportion_5min_role_avg numeric(10,4),
    proportion_5min_role_50 numeric(10,4),
    proportion_5min_role_70 numeric(10,4),
    proportion_5min_role_80 numeric(10,4),
    proportion_5min_role_90 numeric(10,4),
    PRIMARY KEY (ds, tag)
)



CREATE TABLE datasci.ads_industry_50_min_retention_d (
    ds text NOT NULL,
    tag text NOT NULL,
    proportion_ret1_50min_role_avg numeric(10,4),
    proportion_ret1_50min_role_50 numeric(10,4),
    proportion_ret1_50min_role_70 numeric(10,4),
    proportion_ret1_50min_role_80 numeric(10,4),
    proportion_ret1_50min_role_90 numeric(10,4),
    PRIMARY KEY (ds, tag)
)



CREATE TABLE datasci.ads_industry_ice_break_rate_d (
    ds text NOT NULL,
    tag text NOT NULL,
    rate_role_pay_avg numeric(10,4),
    rate_role_pay_50 numeric(10,4),
    rate_role_pay_70 numeric(10,4),
    rate_role_pay_80 numeric(10,4),
    rate_role_pay_90 numeric(10,4),
    PRIMARY KEY (ds, tag)
)


CREATE TABLE datasci.ads_industry_create_role_rate_d (
    ds text NOT NULL,
    tag text NOT NULL,
    rate_role_create_avg numeric(10,4),
    rate_role_create_50 numeric(10,4),
    rate_role_create_70 numeric(10,4),
    rate_role_create_80 numeric(10,4),
    rate_role_create_90 numeric(10,4),
    PRIMARY KEY (ds, tag)
)